package org.processmining.plugins.cosa;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * @author hverbeek
 * 
 *         TARGET ::= token token token token ( "overdue_trigger" OVERDUETRIGGER
 *         | "overdue_triggername" OVERDUETRIGGERNAME | "overdue_reroute"
 *         OVERDUEREROUTE | "calc_command" CALCCOMMAND | "user_feedback"
 *         USERFEEDBACK )
 */
public class CosaTarget extends CosaElement {

	//	private String conditionName;
	//	private String timeBase;
	//	private String intValue;
	//	private String timeType;
	private CosaOverdueTrigger overdueTrigger;
	private final List<CosaOverdueTriggerName> overdueTriggerNameList;
	private final List<CosaOverdueReroute> overdueRerouteList;
	private final List<CosaCalcCommand> calcCommandList;
	private final List<CosaUserFeedback> userFeedbackList;

	public CosaTarget() {
		//		conditionName = null;
		//		timeBase = null;
		//		intValue = null;
		//		timeType = null;
		overdueTrigger = null;
		overdueTriggerNameList = new ArrayList<CosaOverdueTriggerName>();
		overdueRerouteList = new ArrayList<CosaOverdueReroute>();
		calcCommandList = new ArrayList<CosaCalcCommand>();
		userFeedbackList = new ArrayList<CosaUserFeedback>();
	}

	public void parse(CosaStream input, Collection<String> keywords) throws IOException {
		//		conditionName = input.getToken();
		input.advance();
		//		timeBase = input.getToken();
		input.advance();
		//		intValue = input.getToken();
		input.advance();
		//		timeType = input.getToken();
		input.advance();
		while (!keywords.contains(input.getToken())) {
			if (input.getToken().equals("overdue_trigger")) {
				input.advance();
				overdueTrigger = new CosaOverdueTrigger();
				overdueTrigger.parse(input);
			} else if (input.getToken().equals("overdue_triggername")) {
				input.advance();
				CosaOverdueTriggerName overdueTriggerName = new CosaOverdueTriggerName();
				overdueTriggerName.parse(input);
				overdueTriggerNameList.add(overdueTriggerName);
			} else if (input.getToken().equals("overdue_reroute")) {
				input.advance();
				CosaOverdueReroute overdueReroute = new CosaOverdueReroute();
				overdueReroute.parse(input);
				overdueRerouteList.add(overdueReroute);
			} else if (input.getToken().equals("calc_command")) {
				input.advance();
				CosaCalcCommand calcCommand = new CosaCalcCommand();
				calcCommand.parse(input);
				calcCommandList.add(calcCommand);
			} else if (input.getToken().equals("user_feedback")) {
				input.advance();
				CosaUserFeedback userFeedback = new CosaUserFeedback();
				userFeedback.parse(input);
				userFeedbackList.add(userFeedback);
			}
		}
	}
}
